///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//  Copyright  NetworkDLS 2002, All rights reserved
//
// THIS CODE AND INFORMATION IS PROVIDED "AS IS" WITHOUT WARRANTY OF 
// ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING BUT NOT LIMITED TO 
// THE IMPLIED WARRANTIES OF MERCHANTABILITY AND/OR FITNESS FOR A 
// PARTICULAR PURPOSE.
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
#ifndef _CStringBuilder_H
#define _CStringBuilder_H
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

#define CSTRINGBUILDER_GRANDULARITY 1024

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

class CStringBuilder{

public:
	operator const char*(void);
	operator char*(void);
	operator int(void);
	CStringBuilder operator+ (CStringBuilder &pStr);
	CStringBuilder operator+= (CStringBuilder &pStr);
	bool operator== (CStringBuilder &pStr);
	bool operator> (CStringBuilder &pStr);
	bool operator< (CStringBuilder &pStr);
	bool operator>= (CStringBuilder &pStr);
	bool operator<= (CStringBuilder &pStr);
	bool operator!= (CStringBuilder &pStr);
	char &operator[] (unsigned int i);
	char &operator[] (int i);

	bool Initialize(const int iInAllocAhead);
	bool Initialize(void);
	void Destroy(void);

	CStringBuilder(CStringBuilder *pSource);
	CStringBuilder(int InitialSize);
	CStringBuilder(const char *String, int Size);
	CStringBuilder(const char *String);
	CStringBuilder(const char *String, int Size, int InitialSize);
	CStringBuilder(void);
	~CStringBuilder(void);

	bool AppendFromTextBox(HWND hTextBox);
	bool AppendFromFile(const char *sFileName);
	bool AppendFromFileByHandle(FILE *hSource);

	bool Append(CStringBuilder *pBuffer);

	int StrCmp(CStringBuilder *pStr);
	int StrCmpi(CStringBuilder *pStr);
	int StrnCmp(CStringBuilder *pStr, int iChars);
	int StrnCmpi(CStringBuilder *pStr, int iChars);

	bool Append(const int iNum);
	bool Append(const unsigned int iNum);
	bool Append(const long iNum);
	bool Append(const unsigned long iNum);

	bool Append(const __int64 i64Dat2Append);
	bool Append(const unsigned __int64 i64Dat2Append);

	int AppendF(const char *sFormat, ...);
	bool Append(const char *sDat2Append);
	bool Append(const unsigned char *sDat2Append);
	bool Append(const char *sDat2Append, const int iDat2AppendSz);
	bool Append(const unsigned char *sDat2Append, const int iDat2AppendSz);

	bool Append(const char cCharacter2Append);

	bool Append(const float fDat2Append, int iDecimalPlaces);
	bool Append(const float fDat2Append);
	bool Append(const double dDat2Append, int iDecimalPlaces);
	bool Append(const double dDat2Append);

	char *ToString(void);

	int InStr(const char *sSearchFor, int sSearchForSz, const int iStartPos);
	int InStr(const char *sSearchFor, const int iStartPos);
	int InStr(const char *sSearchFor);
	int InStrI(const char *sSearchFor, int sSearchForSz, const int iStartPos);
	int InStrI(const char *sSearchFor, const int iStartPos);
	int InStrI(const char *sSearchFor);

	bool IncreaseSize(int iAdditionalBytes);
	bool Resize(int iAtLeast);

	void Clear(void);
	bool Terminate(void);
	bool Terminate(int iPosition);

	int RemoveWhiteSpaces(void);
	int Trim(void);

	int Replace(const char *sReplace, int iReplaceLen, const char *sWith, int iWithLen, bool bCaseSensitive);
	int Replace(const char *sReplace, const char *sWith, bool bCaseSensitive);
	int Replace(const char *sReplace, const char *sWith);
	int ReplaceRange(int iBegin, int iEnd, const char *sWith, int iWithSz);

	int FirstCharPos(void);
	int LastCharPos(void);

	int Right(char *sOutBuf, int iMaxSz, int iRight);
	int Left(char *sOutBuf, int iMaxSz, int iLeft);

	char *Buffer;

	int Alloc;
	int AllocAhead;
	int Length;
};

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
#endif
